// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('sdb', [
        'ionic',
        'ngCordova',
        'ionic.service.core',
        'ui.bootstrap',
        'sdb.controllers',
        'sdb.services',
        'sdb.directives',
        'sdb.routers',
        'akoenig.deckgrid'
    ])
.config(['$ionicAppProvider', function($ionicAppProvider) {
    // Identify app
    $ionicAppProvider.identify({
        // The App ID (from apps.ionic.io) for the server
        app_id: '1a1ef663',
        // The public API key all services will use for this app
        api_key: 'e6457461a6698074147c2860b0eb55f78e36828109f02719'//,
        // Set the app to use development pushes
        //dev_push: true
    });
}])
.config(function($ionicConfigProvider) {

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');
    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');
    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');
    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');
    $ionicConfigProvider.templates.maxPrefetch(100);

})
.run(function($ionicPlatform,$location,$rootScope,$ionicPopup,$timeout,SysInfo,Auth) {
    $ionicPlatform.ready(function() {
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        }
        if (window.StatusBar) {
            // org.apache.cordova.statusbar required
            StatusBar.styleDefault();
        }
    });
    //初始化版本信息
    if(SysInfo.get_app_version()==""){
        SysInfo.init_info("1.04");
    }
        
    //判断是否显示splash
    $rootScope.flag = {
        show:false,
        show_adprom:false
    };
    //显示splash,首次登录
    if(SysInfo.show_splash()){
        $location.path('/splash').replace();
    }else{
        //非首次登录
        $rootScope.flag.show = true;
        $rootScope.flag.show_adprom = true;
        //验证是否登录，在线验证
        Auth.check_user();
    }
    //设置地理位置信息
    $timeout(function () {
        navigator.geolocation.getCurrentPosition(function () {
        });
    },1000);
    if(ionic.Platform.isAndroid()){
        //检查是否需要更新，读取在线最新版本
        SysInfo.get_online_version().then(function (data) {
            if(data.code == 1){
                if(data.msg.version > SysInfo.get_app_version()){
                    $ionicPopup.confirm({
                        title: "版本更新",
                        template: "发现新版本，是否更新？",
                        buttons: [
                            { text: "取消" },
                            {
                                text: "<b>确认</b>",
                                type: "button-positive",
                                onTap: function() {
                                    return true;
                                }
                            }
                        ]
                    })
                        .then(function(res) {
                            if(res) {
                                cordova.InAppBrowser.open(SysInfo.get_app_download_url(), '_system', 'location=yes');
                            }
                        });
                }
            }
        });
    }
})
//默认loading
.constant("$ionicLoadingConfig",{
    template : "<ion-spinner class='spinner-light' icon=\"lines\"></ion-spinner><br/>正在加载",
    noBackdrop: true
})
.constant('BASE', {
        //基础url
        //url: 'http://172.30.10.6/sdb_app_server/',
        url: 'http://123.57.219.218/',
        //获取系统版本信息
        last_sys_version:'sys_info/last_sys_version',
        //获取系统信息
        sys_info:'sys_info/sys_info',
        //发送短信
        send_sms: 'sms/send_sms',
        //用户登陆
        user_login: 'user/login',
        //获得产品列表
        product_list: 'product/product_list',
        //展示活动的游戏
        show_prom: 'promotion/show_prom',
        //单独获取产品评分和评论数
        product_records:'product/product_records',
        //产品简介
        product_short: 'product/product_short',
        //活动简介
        prom_short:'promotion/prom_short',
        //评论列表
        comment_list:'comment/comment_list',
        //拆红包
        open_bouns:'user/open_bouns',
        //攒金豆
        user_add_dou:'user/user_add_dou',
        //解析qr码
        decode_p:'qr/decode_p',
        //账户明细
        money_detail :'user/user_wallet_detail',
        //我的优惠券
        user_coupon_list:'user/user_coupon_list',
        //获取优惠券使用说明
        award_detail:'award/award_detail',
        //查看大家的手气
        luck_list:'search/luck_list',
        //查用户支付宝账号是否存在
        check_alipay : 'user/user_withdraw_check_alipay',
        //提现到支付宝账号
        user_withdraw: 'user/user_withdraw',
        //获取类别
        product_category: 'product/product_category',
        //根据分类 获取产品列表
        product_list_by_cate_id: 'product/product_list_by_cate_id',
        //查询是否收藏
        is_fav: 'user/is_fav',
        //添加收藏或取消收藏
        set_fav: 'user/set_fav',
        //收藏列表
        my_fav_list: 'user/my_fav_list',
        //添加评论
        comment_add: 'comment/comment_add',
        //获取热门搜索列表
        hot_search_list:'search/hot_search_list',
        //搜索
        get_result:'search/get_result',
        //获取品牌墙
        brand_list:'brand/brand_list',
        //获取某个品牌的商品列表
        brand_products:'brand/brand_products',
        //获取是否有未读消息
        has_message:'message/has_message',
        //获取用户消息
        user_message:'message/user_message',
        //消息已读
        message_has_read:'message/message_has_read',
        //删除消息
        message_delete:'message/message_delete',
        //获取用户扩展信息
        user_meta_info:'user/user_meta_info',
        //修改用户信息
        update_user_info:'user/update_user_info',
        //图片上传
        update_user_img:'user/update_user_img',
        //检查未开启奖励
        check_unopen:'user/check_unopen',
        //获取产品详情
        product_detail:'product/product_detail',
        //验证用户
        check_user:'user/check_user',
        //得到我的页面数量
        my_count:'user/my_count',
        //意见反馈
        add_feedback:'user/add_feedback',
        //输入邀请码
        input_invitation_code:'user/input_invitation_code',
        //热门广告活动banner列表
        ad_prom_list:'ad/ad_prom_list',
        //活动banner详细
        ad_prom_detail:'ad/ad_prom_detail'
    });
