angular.module('sdb.controllers', [])
    .config(function ($httpProvider) {
        $httpProvider.defaults.useXDomain = true;
        delete $httpProvider.defaults.headers.common['X-Requested-With'];
    })
    .controller('SplashCtrl', function ($scope,$location,$rootScope,SysInfo) {
        $scope.go_main = function () {
            $rootScope.flag.show = true;
            SysInfo.set_local_version();
            $location.path('/main').replace();
        };
    })
    .controller('MainCtrl', function ($scope,$state,$ionicPopup,$rootScope,$http, $ionicHistory,$modal,
                                      $ionicSlideBoxDelegate,$timeout,Game,AdpromList,BASE) {
        //清空历史
        $ionicHistory.clearHistory();
        $ionicHistory.viewHistory().histories['root'].cursor = 0;
        /*//初始化百度地图
        UILoad.load("http://api.map.baidu.com/api?v=2.0&ak=GsmmXe04VAdI6QlfZZ1hT1W3").then(function () {
            console.log("success");
        });*/
        var do_qrcode = function (text) {
            var qrcode = Game.url2qrcode(text);
           // alert(qrcode);
            if (qrcode == null) {
                $ionicPopup.alert({
                    title: "提示信息",
                    template: "非有效二维码！"
                });
                return;
            }
            //服务器解析二维码数据
            Game.decode_p(qrcode).then(function (data) {
              //  alert(JSON.stringify(data));
                if(data.code== 1 ){
                    //判断二维码是否用过
                    if (data.msg.is_used == "0") {
                        //跳转产品页
                        $state.go('productinfo', {prod_Id: data.msg.prod_id, game_type: "1"});
                    } else {
                        $state.go('productinfo', {prod_Id: data.msg.prod_id, game_type: "0"});
                        $ionicPopup.alert({
                            title: "提示信息",
                            template: "该二维码已用！"
                        });
                    }
                }else if(data.code==-1){
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "参数错误！"
                    });
                }else if(data.code==-2){
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "非扫得宝二维码！"
                    });
                }else if(data.code == undefined ){
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "网络连接异常！"
                    });
                }else{
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "未知错误！"
                    });
                }

            });
        };
        var show_banner = function () {
            $scope.banner_list = [];
            var adpromlist_conf={
                is_banner:1,
                phone:"",
                token:"",
                area_id:0,
                page_size:3,
                page_index:0
            };
            AdpromList.ad_prom_list(adpromlist_conf).then(function (data) {
                if(data.code == 1){
                    for(var i = 0; i < data.msg.length;i++){
                        var b = data.msg[i];
                        b.img_path = BASE.url + b.img_path;
                        $scope.banner_list.push(b);
                    }
                }
                $ionicSlideBoxDelegate.update();
            });
        };
        var update_banner = function () {
            var adpromlist_conf={
                is_banner:1,
                phone:"",
                token:"",
                area_id:0,
                page_size:3,
                page_index:0
            };
            AdpromList.ad_prom_list(adpromlist_conf).then(function (data) {
                if(data.code == 1){
                    for(var i = 0; i < data.msg.length;i++){
                        var b = data.msg[i];
                        b.img_path = BASE.url + b.img_path;
                        if($scope.banner_list[i]!=undefined){
                            $scope.banner_list[i] = b;
                        }else{
                            $scope.banner_list.push(b);
                        }
                    }
                }
                $ionicSlideBoxDelegate.update();
                $scope.$broadcast("scroll.refreshComplete");
            });
        };
        //doRefresh
        $scope.doRefresh = function () {
            update_banner();
        };
        //扫一扫
        $scope.scaning = false;
        $scope.scanBarcode = function () {
            if($scope.scaning)
            {
                return;
            }
            $scope.scaning = true;
            cordova.plugins.barcodeScanner.scan(
                function (result) {
                    $scope.scaning = false;
                    if(result.cancelled){
                    //alert("the user cancelled the scan");
                    }else{
                    do_qrcode(result.text);
                        //alert(result.text);
                    }
                    
                },
                function (error) {
                    $scope.scaning = false;
              //      alert("Scanning failed: " + error);
                }
            );
        };
        $scope.go_bannerinfo = function (banner_id) {
            $state.go('adprom-info',{adprom_id:banner_id});
        };
        show_banner();
        $scope.$on('$ionicView.afterEnter', function () {
            if(!$rootScope.flag.show_adprom)
            {
                $rootScope.flag.show_adprom = true;
                $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/show_prom.html',
                    size: 'show-prom',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalShowPromCtrl'
                });
            }
        });
    })
    .controller('AreaCityCtrl', function ($scope,$timeout) {
        $scope.flag = {
            local_city:"定位中",
            msg:""
        };
        navigator.geolocation.getCurrentPosition(function(position){
            var map = new BMap.Map("allmap");
            var point = new BMap.Point(position.coords.longitude,position.coords.latitude);
            map.centerAndZoom(point,12);
            function myFun(result){
                var cityName = result.name;
                map.setCenter(cityName);
                $scope.flag.local_city = cityName;
            }
            var myCity = new BMap.LocalCity();
            myCity.get(myFun);
        }, function(err){});
        $timeout(function () {
            if($scope.flag.local_city == "定位中"){
                $scope.flag.local_city = "未知";
                $scope.flag.msg = "定位超时，请返回后重新进入本页面";
            }
        },5000);

    })
    .controller('ShowPageCtrl', function ($scope,$stateParams,$timeout,$ionicHistory,SysInfo) {
        $scope.page_info = {};
        SysInfo.sys_info($stateParams.page_id).then(function (data) {
            if(data.code == 1){
                $scope.page_info.title = data.msg.name;
                $scope.page_info.content = data.msg.content;
                $scope.page_info.back_title = $ionicHistory.backTitle();
            }
        });
    })
    .controller('AdpromInfoCtrl', function ($scope,$stateParams,$timeout,$ionicHistory,AdpromList) {
        $scope.adprom_info = {};
        AdpromList.ad_prom_detail($stateParams.adprom_id).then(function (data) {
            if(data.code == 1){
                $scope.adprom_info = data.msg;
                $scope.adprom_info.back_title = $ionicHistory.backTitle();
            }
        });
    })
    .controller('AdpromListCtrl', function ($scope,$timeout,AdpromList,BASE) {
        $scope.adpromlist_conf={
            is_banner:0,
            phone:"",
            token:"",
            area_id:0,
            page_size:3,
            page_index:0
        };
        //是否需要显示下拉刷新
        $scope.flag ={
            showmore:false,
            result:""};
        var func_show_adpromlist = function (init) {
            if(init){
                $scope.adpromlist = [];
                $scope.adpromlist_conf.page_index = 0
            }else{
                $scope.adpromlist_conf.page_index ++;
            }
            AdpromList.ad_prom_list($scope.adpromlist_conf).then(function (data) {
                if(data.code == undefined){
                    $scope.flag.result = "网络连接异常，请返回后重新进入本页尝试";
                    return;
                }
                if(data.code == 0){
                    if($scope.adpromlist.length == 0){
                        $scope.flag.result = "当前没有活动";
                    }else{
                        $scope.flag.result = "没有更多的活动了";
                        $scope.flag.showmore = false;
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    return;
                }
                if(data.code == 1){
                    $scope.flag.result = "";
                    for(var i = 0; i < data.msg.length;i++){
                        data.msg[i].img_path = BASE.url + data.msg[i].img_path;
                        $scope.adpromlist.push(data.msg[i]);
                    }
                    if($scope.adpromlist.length >= $scope.adpromlist_conf.page_size){
                        $timeout(function () {
                            $scope.flag.showmore = true;
                        },1000);
                    }
                //    console.log($scope.adpromlist);
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                }
            }, function (err) {
               // console.log(err);
                $scope.flag.result = "网络连接异常，请返回后重新进入本页尝试";
            });
        };
        func_show_adpromlist(true);
        $scope.load_more = function () {
            $timeout(function () {
                func_show_adpromlist(false);
            },500);
        };

    })
    .controller('MsglistCtrl', function ($scope,$modal,$ionicPopup,Msg,Auth) {
        $scope.flag={
            showDelete:false
        };
        $scope.user_msg_conf={};
        $scope.mlist = [];
        var load_msglist = function () {
            //读取用户消息
            Msg.user_message($scope.user_msg_conf).then(function (data) {
                if(data.code == "1")
                {
                    $scope.mlist = data.msg;
                    //存储msglist
                    Msg.set_msglist(data.msg);
                }
            });
        };
        $scope.$on('$ionicView.beforeEnter', function () {
            if(!Auth.islogin()){
                $scope.user_msg_conf={};
            }else{
                $scope.user_msg_conf={
                    phone:Auth.getUser().phone,
                    token:Auth.getUser().token
                };
                load_msglist();
            }
        });
        //
        $scope.delete_item_bat=function(idx){
            Msg.message_delete($scope.mlist[idx].id).then(function (data) {
                if(data.code == 1)
                {
                    $scope.mlist.splice(idx,1);
                }
            });
        };
        $scope.delete_item=function(idx){
            // 确认弹出框
            $ionicPopup.confirm({
                title: "确定删除该消息么？",
                buttons: [
                    { text: "取消"},
                    {
                        text: "<b>确定</b>",
                        type: "button-assertive",
                        onTap: function(e) {
                            return true;
                        }
                    }
                ]
            })
            .then(function(res) {
                if(res) {
                    Msg.message_delete($scope.mlist[idx].id).then(function (data) {
                        if(data.code == 1)
                        {
                            $scope.mlist.splice(idx,1);
                        }
                    });
                }
            });
        };
        $scope.open_login = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_login.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalLoginCtrl'
            });
            modalInstance.result.then(function () {
                $scope.user_msg_conf={
                    phone:Auth.getUser().phone,
                    token:Auth.getUser().token
                };
                load_msglist();
            }, function () {
            });
        };
    })
    .controller('MsginfoCtrl', function ($scope,$stateParams,Msg) {
        $scope.msg ={};
        $scope.msg = Msg.get_msginfo($stateParams.msg_idx);
        if($scope.msg != undefined && $scope.msg.state == "0")
        {
            Msg.message_has_read($scope.msg.id);
        }
    })
    .controller('SearchCtrl', function ($scope,$timeout,Search,BASE) {
        $scope.slist = [];
        $scope.plist = [];
        $scope.prom_name = ["未知","红包","金豆","集点"];
        $scope.post_conf = {
            page_size:"10",
            page_index:"0",
            content:"",
            desc_col:"average"
        };
        //是否需要显示下拉刷新
        $scope.flag ={showmore:false,result:""};
        var search_result = function () {
            Search.get_result($scope.post_conf).then(function (data) {
                //不存在搜索结果清空列表，删除more控件
                if(data.code !=1)
                {
                    $scope.flag.showmore = false;
                    if($scope.plist.length==0){
                        $scope.flag.result = "未搜索到相关结果";
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    return;
                }
                for (var i = 0; i < data.msg.length; i++) {
                    var p = data.msg[i];
                    //列表转成小图
                    var r = p.img_path.split('/');
                    r[r.length-1] = 's_'+r[2];
                    p.img_path = BASE.url + r.join('/');
                    // p.average == null ? p.average = 0 : "";
                    p.ratingStates = [
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}];
                    if (p.average == null || p.average == 0) {
                        p.rating = 5;
                    } else {
                        p.rating = Math.floor(p.average / 20) + 1;
                        //如果有半星的话
                        if (p.average % 20 != 0) {
                            p.ratingStates[Math.floor(p.average / 20)] = {
                                stateOn: 'ion-ios-star-half',
                                stateOff: 'ion-ios-star-outline'
                            };
                        }
                    }
                    p.comment_num == null ? p.comment_num = 0 : "";
                    $scope.plist.push(p);
                }
                if($scope.plist.length >= $scope.post_conf.page_size)
                {
                    $timeout(function () {
                        $scope.flag.showmore = true;
                    },1000);
                }
                $scope.$broadcast("scroll.infiniteScrollComplete");
            });
        };
        /*$scope.clear_content = function () {
            $scope.post_conf.content = "";
        };*/
        //热门搜索列表
        Search.hot_search_list().then(function (data) {
            if(data.code == "1")
                $scope.slist = data.msg;
        });
        //选择热门搜索项
        $scope.select = function (index) {
            $scope.post_conf.content = $scope.slist[index].key_word;
        };
        //监视输入框变化
        $scope.$watch('post_conf.content', function (){
            if($scope.post_conf.content == "")
                return;
            $scope.post_conf.page_index = 0;
            $scope.plist = [];
            $scope.flag.result = "";
            search_result();
        });
        $scope.load_more = function () {
            $scope.post_conf.page_index++;
            $timeout(function () {
                search_result();
            },500);
        };

    })
    .controller('CategoryCtrl', function ($scope,$ionicScrollDelegate,$timeout,$ionicLoading,BASE, Product) {
        $ionicLoading.show();
        $scope.flag = {
            select_cate:0,
            showmore:false
        };
        $scope.prom_name = ["未知","红包","金豆","集点"];
        $scope.post_conf = {
            cate_id:7,
            cate_level:2,
            page_size:20,
            page_index:0,
            desc_col:"average"
        };
        $scope.plist = [];
        //绑定分类
        var func_show_category = function () {
            $scope.clist = [];
            Product.get_category().then(function (data) {
                $scope.flag.result = "";
                $ionicLoading.hide();
                angular.forEach(data, function (c1) {
                    if(c1.next != undefined){
                        angular.forEach(c1.next, function (c2) {
                            $scope.clist.push(c2);
                        });
                    }
                });
            }, function () {
                $ionicLoading.hide();
                $scope.flag.result = "网络连接异常，请返回后重新进入本页尝试";
            });
        };
        //按类别读取产品列表
        var func_show_product = function (init) {
            if(init){
                $scope.plist = [];
                $scope.post_conf.page_index = 0
            }else{
                $scope.post_conf.page_index ++;
            }
            Product.product_list_by_cate_id($scope.post_conf).then(function (data) {
                if(data.code !=1)
                {
                    $scope.flag.showmore =false;
                    if($scope.plist.length==0){
                        $scope.flag.result ="该分类下没有相关产品";
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    if(data.code == undefined){
                        $scope.flag.result ="网络连接异常，请返回后重新进入本页尝试";
                    }
                    return;
                }
                $scope.flag.result ="";
                for (var i = 0; i < data.msg.length; i++) {
                    var p = data.msg[i];
                    //列表转成小图
                    var r = p.img_path.split('/');
                    r[r.length-1] = 's_'+r[2];
                    p.img_path = BASE.url + r.join('/');
                    // p.average == null ? p.average = 0 : "";
                    p.ratingStates = [
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}];
                    if (p.average == null || p.average == 0) {
                        p.rating = 5;
                    } else {
                        p.rating = Math.floor(p.average / 20) + 1;
                        //如果有半星的话
                        if (p.average % 20 != 0) {
                            p.ratingStates[Math.floor(p.average / 20)] = {
                                stateOn: 'ion-ios-star-half',
                                stateOff: 'ion-ios-star-outline'
                            };
                        }
                    }
                    p.comment_num == null ? p.comment_num = 0 : "";
                    $scope.plist.push(p);
                }
                if($scope.plist.length >= $scope.post_conf.page_size)
                {
                    $timeout(function () {
                        $scope.flag.showmore = true;
                    },1000);
                }
                $scope.$broadcast("scroll.infiniteScrollComplete");
            });
        };
        //通过分类id查询产品列表
        $scope.get_product_bycate = function (cate_id,index) {
            $ionicScrollDelegate.$getByHandle('cate_menu').scrollTo(0,38*index,true);
            $ionicScrollDelegate.$getByHandle('cate_list').scrollTop();
            $scope.flag.select_cate = index;
            $scope.post_conf.cate_id = cate_id;
            $scope.flag.showmore =false;
            func_show_product(true);
        };
        $scope.load_more = function () {
            func_show_product(false);
        };
        //页面初始化数据
        func_show_category();
        func_show_product(true);
    })
    .controller('BrandCtrl', function ($scope,$timeout,$ionicLoading,Brand,BASE) {
        $scope.post_conf = {
            page_size:12,
            page_index:0,
            desc_col:"score"
        };
        //是否需要显示下拉刷新
        $scope.flag ={
            showmore:false,
            result:""
        };
        $scope.blist = [];
        var func_show_brandlist = function (init) {
            if(init){
                $ionicLoading.show();
                $scope.blist = [];
                $scope.post_conf.page_index = 0
            }else{
                $scope.post_conf.page_index ++;
            }
            Brand.brand_list($scope.post_conf).then(function (data) {
                $ionicLoading.hide();
                if(data.code == undefined){
                    $scope.flag.result = "网络连接异常，请返回后重新进入本页尝试";
                    return;
                }
                $scope.flag.result = "";
                if(data.code == "1")
                {
                    for (var i = 0; i < data.msg.length; i++) {
                        data.msg[i].img_path = BASE.url + data.msg[i].img_path;
                        $scope.blist.push(data.msg[i]);
                    }
                    //如果列表需要翻页，显示刷新
                    if($scope.blist.length >= $scope.post_conf.page_size){
                        $timeout(function() {
                            $scope.flag.showmore = true;
                        },1000);
                    }
                }else{
                    $scope.flag.showmore = false;
                }
            }, function () {
                $scope.flag.result = "网络连接异常，请返回后重新进入本页尝试";
                $ionicLoading.hide();
            });
        };
        //翻页读取更多
        $scope.load_more = function () {
            $timeout(function() {
                func_show_brandlist(false);
                $scope.$broadcast("scroll.infiniteScrollComplete");
            },500);
        };
        $scope.doRefresh = function () {
            func_show_brandlist(true);
            $scope.$broadcast("scroll.refreshComplete");
        };
        //页面初始化
        func_show_brandlist(true);
    })
    .controller('BrandProdlistCtrl', function ($scope,$stateParams,Brand,BASE) {
        $scope.post_conf = {
            brand_id:$stateParams.bid,
            page_size:100,
            page_index:0,
            desc_col:"average"
        };
        $scope.prom_name = ["未知","红包","金豆","集点"];
        //是否需要显示下拉刷新
        $scope.flag ={showmore:true,result:""};
        $scope.plist = [];
        //翻页读取更多
        $scope.load_more = function () {
            Brand.brand_products($scope.post_conf).then(function (data) {
                //console.log(data);
                if (data.code !== "1") {
                    $scope.flag.showmore = false;
                    if($scope.plist.length == 0)
                    {
                        $scope.flag.result = "该品牌还没有录入产品！";
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    return;
                }
                $scope.flag.result = "";
                //翻页
                $scope.post_conf.page_index++;
                for (var i = 0; i < data.msg.length; i++) {
                    var p = data.msg[i];
                    //列表转成小图
                    var r = p.img_path.split('/');
                    r[r.length-1] = 's_'+r[2];
                    p.img_path = BASE.url + r.join('/');
                    // p.average == null ? p.average = 0 : "";
                    p.ratingStates = [
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}];
                    if (p.average == null || p.average == 0) {
                        p.rating = 5;
                    } else {
                        p.rating = Math.floor(p.average / 20) + 1;
                        //如果有半星的话
                        if (p.average % 20 != 0) {
                            p.ratingStates[Math.floor(p.average / 20)] = {
                                stateOn: 'ion-ios-star-half',
                                stateOff: 'ion-ios-star-outline'
                            };
                        }
                    }
                    p.comment_num == null ? p.comment_num = 0 : "";
                    $scope.plist.push(p);
                }
                $scope.$broadcast("scroll.infiniteScrollComplete");
            })
        };
    })
    .controller('TabCtrl', function ($scope, $state,Auth,Msg) {
        $scope.scanBarcode = function () {
            $state.go('scanner');
        };
        $scope.msg = {count:""};
        if(Auth.islogin())
        {
            var user = {
                phone:Auth.getUser().phone,
                token:Auth.getUser().token
            };
            Msg.has_message(user).then(function (data) {
                if(data.code =="1"){
                    $scope.msg.count = data.msg;
                }else if(data.code == "-4"){
                    Auth.logout();
                }
            });
        }
        $scope.clear_count = function () {
            $scope.msg.count = "";
        };
    })
    .controller('MyCollectionCardCtrl', function ($scope,Mycoupons,BASE,Auth) {
        $scope.btn = {index: "1"};
        $scope.$on('$ionicView.beforeEnter', function () {
            $scope.clist_unuse = [];
            $scope.clist_useing = [];
            $scope.clist_used = [];
            get_coupons(1);
            get_coupons(2);
            get_coupons(3);
        });
        $scope.show_unuse = function () {
            $scope.btn.index = 1;
        };
        $scope.show_useing = function () {
            $scope.btn.index = 2;
        };
        $scope.show_used = function () {
            $scope.btn.index = 3;
        };
        $scope.go_award_detail = function (awrad_id) {
            alert(awrad_id);
        };
        var get_coupons =  function (state_id) {
            if(!Auth.islogin())
                return;
            var post_conf = {
                phone:Auth.getUser().phone,
                token:Auth.getUser().token,
                page_size:10,
                page_index:0,
                desc_col:"update_date",
                type_id:"3",//集点卡
                state_id:state_id
            };
            Mycoupons.user_coupon_list(post_conf).then(function (data) {
                if(data.code == 1)
                {
                    if(state_id == 1){
                        for(var i = 0;i< data.msg.length;i++){
                            data.msg[i].award_img_path = BASE.url + data.msg[i].award_img_path;
                            $scope.clist_unuse.push(data.msg[i]);
                        }
                    }else if(state_id == 2){
                        for(var i = 0;i< data.msg.length;i++){
                            data.msg[i].award_img_path = BASE.url + data.msg[i].award_img_path;
                            $scope.clist_useing.push(data.msg[i]);
                            console.log(data.msg);
                        }
                    }else if(state_id == 3){
                        for(var i = 0;i< data.msg.length;i++){
                            data.msg[i].award_img_path = BASE.url + data.msg[i].award_img_path;
                            $scope.clist_used.push(data.msg[i]);
                        }
                    }
                }
            });
        };
    })
    .controller('AwardDetailCtrl', function ($scope,$stateParams,Mycoupons) {
        $scope.award={detail:""};
        Mycoupons.award_detail($stateParams.award_id).then(function (data) {
           if(data.code == 1){
               $scope.award.detail = data.msg.detail;
           }
        });
    })
    .controller('MyCouponsCtrl', function ($scope,$state,$stateParams,Mycoupons,BASE,Auth) {
        $scope.btn = {index: "1"};
        $scope.$on('$ionicView.beforeEnter', function () {
            $scope.clist_unuse = [];
            $scope.clist_useing = [];
            $scope.clist_used = [];
            get_coupons(1);
            get_coupons(2);
            get_coupons(3);
        });
        $scope.show_unuse = function () {
            $scope.btn.index = 1;
        };
        $scope.show_useing = function () {
            $scope.btn.index = 2;
        };
        $scope.show_used = function () {
            $scope.btn.index = 3;
        };
        $scope.go_award_detail = function (awrad_id) {
            $state.go('award_detail',{'award_id':$stateParams.award_id});
        };
        var get_coupons =  function (state_id) {
            if(!Auth.islogin())
                return;
            var post_conf = {
                phone:Auth.getUser().phone,
                token:Auth.getUser().token,
                page_size:10,
                page_index:0,
                desc_col:"update_date",
                type_id:"2",//攒豆
                state_id:state_id
            };
            Mycoupons.user_coupon_list(post_conf).then(function (data) {
                if(data.code == 1)
                {
                    if(state_id == 1){
                        for(var i = 0;i< data.msg.length;i++){
                            data.msg[i].award_img_path = BASE.url + data.msg[i].award_img_path;
                            $scope.clist_unuse.push(data.msg[i]);
                        }
                    }else if(state_id == 2){
                        for(var i = 0;i< data.msg.length;i++){
                            data.msg[i].award_img_path = BASE.url + data.msg[i].award_img_path;
                            $scope.clist_useing.push(data.msg[i]);
                        }
                    }else if(state_id == 3){
                        for(var i = 0;i< data.msg.length;i++){
                            data.msg[i].award_img_path = BASE.url + data.msg[i].award_img_path;
                            $scope.clist_used.push(data.msg[i]);
                        }
                    }
                }
            });
        };

    })
    //查看大家手气
    .controller('LucklistCtrl', function ($scope,$stateParams,Game) {
        $scope.post_conf = {
            prom_id:$stateParams.prom_id,
            page_size: 10,
            page_index: 0,
            desc_col: "create_date"
        };
        //是否需要显示下拉刷新
        $scope.flag ={showmore:true,result:""};
        $scope.plist = [];
        //翻页读取更多
        $scope.load_more = function () {
            Game.luck_list($scope.post_conf).then(function (data) {
              //  console.log(data);
                if (data.code !== "1") {
                    $scope.flag.showmore = false;
                    if($scope.plist.length == 0)
                    {
                        $scope.flag.result = "没有人抽取过该红包！";
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    return;
                }
                $scope.flag.result = "";
                //翻页
                $scope.post_conf.page_index++;
                for (var i = 0; i < data.msg.length; i++) {
                    var p = data.msg[i];
                   $scope.plist.push(p);
                }
                $scope.$broadcast("scroll.infiniteScrollComplete");
            });
        };
    })
    //账户明细
    .controller('MoneydetailCtrl', function ($scope, $modal,$timeout, Mywallet) {
        //打开账户明细
        $scope.wallet = {money: ""};
        $scope.post_conf = {
            page_size: 10,
            page_index: 0
        };
        $scope.flag ={showmore:false,result:""};
        var show_money_detail =  function (init) {
            if(init){
                $scope.loglist = [];
                $scope.post_conf.page_index = 0
            }else{
                $scope.post_conf.page_index ++;
            }

            Mywallet.money_detail($scope.post_conf).then(function (data) {
                if (data.code == undefined) {
                    $scope.flag.showmore =false;
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    return;
                }
                if (data.code == "1") {
                    $scope.wallet.money = data.msg.money;
                    for(var i = 0;i<data.msg.log.length;i++){
                        $scope.loglist.push(data.msg.log[i]);
                    }
                } else if (data.code == "-4") {
                    var modalInstance = $modal.open({
                        animation: 'side-in-up',
                        templateUrl: 'templates/modal/to_login.html',
                        size: 'margin',
                        windowClass:'modal_sdb',
                        backdropClass:"modal_sdb_drop",
                        controller: 'ModalLoginCtrl'
                    });
                    modalInstance.result.then(function () {
                        show_money_detail(true);
                    }, function () {
                       // console.log('Modal dismissed at: ' + new Date());
                    });
                }
                if($scope.loglist.length >= $scope.post_conf.page_size)
                {
                    $timeout(function () {
                        $scope.flag.showmore = true;
                    },1000);
                }
                $scope.$broadcast("scroll.infiniteScrollComplete");
            });
        };
        $scope.load_more = function () {
            $timeout(function () {
                show_money_detail(false);
            },500);
        };
        show_money_detail(true);
        var open_alipayModal = function (data) {
            //打开支付宝提现modal
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_alipay.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalToAlipayCtrl',
                resolve: {
                    draw_info: function () {
                        var draw_info = {};
                        draw_info = data;
                        draw_info.money = $scope.wallet.money;
                        return draw_info;
                    }
                }
            });
            modalInstance.result.then(function () {
                load_money_detail();
            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
        //打开提现modal
        $scope.withdraw_modal = function () {
            $scope.alipay = {id: "", name: ""};
            Mywallet.check_alipay().then(function (data) {
                if(data.code == "1"){
                    open_alipayModal(data.msg);
                }else{
                    open_alipayModal($scope.alipay);
                }
            });
        };
    })
    //我的钱包
    .controller('MywalletCtrl', function ($scope, $location, $modal, Auth) {
        $scope.goto_moneydetail = function () {
            if (!Auth.islogin()) {
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function () {
                    $location.path($location.path() + "/money_detail");
                }, function () {
                    //console.log('Modal dismissed at: ' + new Date());
                });

            } else {
                $location.path($location.path() + "/money_detail");
            }
        };
        $scope.goto_mycoupons = function () {
            if (!Auth.islogin()) {
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function () {
                        $location.path($location.path() + "/my-coupons");
                }, function () {
                    //console.log('Modal dismissed at: ' + new Date());
                });

            } else {
                $location.path($location.path() + "/my-coupons");
            }
        };
    })
    .controller('FavoriteCtrl', function ($scope, $modal, $ionicLoading, $timeout, BASE,Auth, MyFavorite) {
        $scope.user = {};
        $scope.hasfav = false;
        $scope.flag={showDelete:false};
        $scope.prom_name = ["未知","红包","金豆","集点"];
        $scope.open_login = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_login.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalLoginCtrl'
            });
            modalInstance.result.then(function () {
                $scope.user.phone = Auth.getUser().phone;
                $scope.user.token = Auth.getUser().token;
            }, function () {
            });
        };

        var load_fav = function () {
            $scope.plist = [];
            MyFavorite.my_fav_list().then(function (data) {
                if (data.code == "0") {
                    $scope.hasfav = false;
                    return;
                } else if (data.code == "1") {
                    $scope.hasfav = true;
                    for (var i = 0; i < data.msg.length; i++) {
                        var p = data.msg[i];
                        //列表转成小图
                        var r = p.img_path.split('/');
                        r[r.length-1] = 's_'+r[2];
                        p.img_path = BASE.url + r.join('/');
                        // p.average == null ? p.average = 0 : "";
                        p.ratingStates = [
                            {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                            {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                            {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                            {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                            {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}];
                        if (p.average == null || p.average == 0) {
                            p.rating = 5;
                        } else {
                            p.rating = Math.floor(p.average / 20) + 1;
                            //如果有半星的话
                            if (p.average % 20 != 0) {
                                p.ratingStates[Math.floor(p.average / 20)] = {
                                    stateOn: 'ion-ios-star-half',
                                    stateOff: 'ion-ios-star-outline'
                                };
                            }
                        }
                        p.comment_num == null ? p.comment_num = 0 : "";
                        $scope.plist.push(p);
                    }
                }
            });
        };
        $scope.del_fav = function (prod_id, index) {
            if (!Auth.islogin()) {
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function (msg) {
                    if (msg == "login-success") {
                        MyFavorite.set_fav(prod_id, 0).then(function (data) {
                            if (data.code == "1") {
                                $scope.plist.splice(index, 1);
                                $ionicLoading.show({
                                    template: "删除收藏成功",
                                    duration: 500
                                });
                            } else {
                       //         console.log(data);
                            }
                        })
                    } else {
                        $scope.user = {};
                    }
                }, function () {
                });
            } else {
                MyFavorite.set_fav(prod_id, 0).then(function (data) {
                    if (data.code == "1") {
                        $scope.plist.splice(index, 1);
                        $ionicLoading.show({
                            template: "删除收藏成功",
                            duration: 500
                        });
                    } else {
                  //      console.log(data);
                    }
                })
            }
        };
        //收藏列表
        //每次进入刷新
        if (Auth.islogin()) {
            $scope.user.phone = Auth.getUser().phone;
            $scope.user.token = Auth.getUser().token;
            load_fav();
        } else {
            $scope.user = {};
        }
        //--------------------------页面重新加载数据----------
        {
            $scope.view_iscache = false;
            $scope.$on('$ionicView.leave', function () {
                $scope.view_iscache = true;
            });
            $scope.$on('$ionicView.beforeEnter', function () {
                if($scope.view_iscache){
                    if (Auth.islogin()) {
                        $scope.user.phone = Auth.getUser().phone;
                        $scope.user.token = Auth.getUser().token;
                        load_fav();
                    } else {
                        $scope.user = {};
                    }
                }
            });
        }
    })
    //产品详情
    .controller('ProductdetailCtrl', function ($scope,$stateParams,$ionicScrollDelegate,Product){
        $scope.product = {
            index:1,
            detail:"",
            args_list:[],
            company_info:""
            };
        $scope.select = function (idx) {
            $scope.product.index = idx;
            $ionicScrollDelegate.scrollTop();
        };
        Product.product_detail($stateParams.prod_Id).then(function (data) {
            if(data.code == 1){
                $scope.product.detail = data.msg.detail_info;
                $scope.product.company_info = data.msg.comp_info;
                if(data.msg.param_list != undefined){
                    $scope.product.args_list = JSON.parse(data.msg.param_list);
                }
                $ionicScrollDelegate.resize();
            }
        });
    })
    .controller('ProductinfoCtrl', function (
        $scope, $state, $stateParams,$location,
        $modal, $ionicPopup,$ionicLoading,BASE, Game, Product,
        Promotion, Auth, Comment, MyFavorite) {
        //--------------------------函数变量初始化---------------
        {
           //展示产品信息
        var show_product = function () {
            Product.prod_info_short($stateParams.prod_Id).then(function (data) {
                var p = data;
                p.ratingStates = [
                    {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                    {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                    {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                    {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                    {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}
                ];
                p.img_path = BASE.url + p.img_path;
                if (p.average == null || p.average == 0) {
                    p.rating = 5;
                } else if (p.average == 100) {
                    p.rating = 5;
                } else {
                    p.rating = Math.floor(p.average / 20) + 1;
                    //如果有半星的话
                    if (p.average % 20 != 0) {
                        p.ratingStates[Math.floor(p.average / 20)] = {
                            stateOn: 'ion-ios-star-half',
                            stateOff: 'ion-ios-star-outline'
                        };
                    }
                }
                $scope.prod = p;
                //获取对应views的路由url
                $scope.prod.addcomm_url = "/addcomm/" + $scope.prod.prod_id;
                if ($scope.prod.comment_num == 0) {
                    $scope.prod.commlist_url = null;
                } else {
                    $scope.prod.commlist_url = "#/commlist/" + $scope.prod.prod_id;
                }
            });
        };
        $scope.comm = {result: ""};
        $scope.commlist = [];
        //评论列表
        var show_comm = function () {
            $scope.comm = {result: ""};
            $scope.commlist = [];
            Comment.comment_list_short($stateParams.prod_Id).then(function (data) {
                //为空返回
                if (data == null) {
                    $scope.comm.result = "主人，还没有人评论呢~~~";
                    return;
                }
                $scope.comm.result = "";
                for (var i = 0; i < data.length; i++) {
                    var p = data[i];
                    p.ratingStates = [
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}
                    ];
                    if (p.score == null || p.score == 0) {
                        p.rating = 5;
                    } else if (p.score == 100) {
                        p.rating = 5;
                    } else {
                        p.rating = Math.floor(p.score / 20) + 1;
                        //如果有半星的话
                        if (p.score % 20 != 0) {
                            p.ratingStates[Math.floor(p.score / 20)] = {
                                stateOn: 'ion-ios-star-half',
                                stateOff: 'ion-ios-star-outline'
                            };
                        }
                    }
                    $scope.commlist.push(p);
                }
            });
        };
        var update_comm_count = function () {
            Product.product_records($stateParams.prod_Id).then(function (data) {
              if(data.code == 1){
                  $scope.prod.ratingStates =  [
                          {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                          {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                          {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                          {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                          {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}
                      ];
                  if (data.msg.average == null || data.msg.average == 0 || data.msg.average == 100) {
                      $scope.prod.rating = 5;
                  } else {
                      $scope.prod.rating = Math.floor(data.msg.average / 20) + 1;
                      //如果有半星的话
                      if (data.msg.average % 20 != 0) {
                          $scope.prod.ratingStates[Math.floor(data.msg.average / 20)] = {
                              stateOn: 'ion-ios-star-half',
                              stateOff: 'ion-ios-star-outline'
                          };
                      }
                  }
                  $scope.prod.comment_num = data.msg.comment_num;
              }
            });
        };
        var show_game = function () {
        var user = {
            phone:"",
            token:""
        };
        if(Auth.getUser()){
            user.phone = Auth.getUser().phone;
            user.token = Auth.getUser().token;
        }
        //显示游戏
        Game.show_prom(user).then(function (data) {
            if (data.code == 1) {
                //设置地理位置信息
                navigator.geolocation.getCurrentPosition(function(position){
                    Game.set_postion(position);
                }, function(){});
                //alert(JSON.stringify(data));
                //保存游戏信息
                Game.set_game_info(data.msg);
                if(data.msg.prom_type_id == 1){
                    var modalInstance = $modal.open({
                        animation: true,
                        templateUrl: 'templates/modal/game_bouns.html',
                        controller: 'ModalGameBounsCtrl',
                        windowClass:'modal_game',
                        backdropClass:"modal_sdb_drop",
                        resolve: {
                            prom_info: function () {
                                return data.msg;
                            }
                        }
                    });
                }else if(data.msg.prom_type_id == 2){
                    var modalInstance = $modal.open({
                        animation: true,
                        templateUrl: 'templates/modal/game_goldbean.html',
                        controller: 'ModalGameGoldBeanCtrl',
                        windowClass:'modal_game',
                        backdropClass:"modal_sdb_drop",
                        resolve: {
                            prom_info: function () {
                                return data.msg;
                            }
                        }
                    });
                }else if(data.msg.prom_type_id == 3){
                    var modalInstance = $modal.open({
                        animation: true,
                        templateUrl: 'templates/modal/game_collection_card.html',
                        controller: 'ModalGameCollectionCardCtrl',
                        windowClass:'modal_game',
                        backdropClass:"modal_sdb_drop",
                        resolve: {
                            prom_info: function () {
                                return data.msg;
                            }
                        }
                    });
                }else{

                }
                //拆完红包，跳转账户明细
                modalInstance.result.then(function (data) {
                    if (data.length == 1) {
                        $state.go(data[0]);
                    } else {
                        $state.go(data[0], data[1]);
                    }
                }, function () {
                    //console.log('Modal dismissed at: ' + new Date());
                });
            } else if(data.code == -4){
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function () {
                    //登录成功，显示游戏
                    show_game();
                }, function () {
                    //console.log('Modal dismissed at: ' + new Date());
                });
            }else{
                $ionicPopup.alert({
                    title: "提示信息",
                    template: data.msg
                });
            }
        });
        };
        var set_fav_func = function (tag) {
            var tmp_str = "";
            var tmp_icon = "";
            if (tag == 0) {
                tmp_str = "取消收藏成功";
                tmp_icon = "img_icon_heart_outline";
            } else if (tag == 1) {
                tmp_str = "添加收藏成功";
                tmp_icon = "img_icon_heart";
            }
            //登陆成功，添加收藏
            MyFavorite.set_fav($stateParams.prod_Id, tag).then(function (data) {
                if (data.code == "1") {
                    $scope.fav.is_fav = tmp_icon;
                    $ionicLoading.show({
                        template: tmp_str,
                        duration: 500
                    });
                } else {
             //       console.log(data);
                }
            })
        };
    }
        //--------------------------页面click方法----------
        {
            $scope.go_prodcut_detail = function () {
                if($scope.prod.has_detail == 1){
                    $state.go('product-detail',{'prod_Id':$stateParams.prod_Id});
                }
            };
            $scope.openurl = function (url) {
                cordova.InAppBrowser.open(url, '_blank', 'location=yes');
            };
          //跳转添加评论
        $scope.go_addcomm = function () {
            if (Auth.islogin()) {
                $location.path($scope.prod.addcomm_url);
            } else {
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function () {
                    $location.path($scope.prod.addcomm_url);
                }, function () {
                });
            }
        };
        //打开活动信息modal
        $scope.open_prominfoModal = function (prom) {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/prom_info.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalPromInfoCtrl',
                resolve: {
                    prom_info: function () {
                        return prom;
                    }
                }
            });
            modalInstance.result.then(function (msg) {

            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
        //点击收藏按钮
        $scope.set_fav = function () {
            //未登陆，跳转登陆
            if (!Auth.islogin()) {
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function () {
                    //添加收藏
                    set_fav_func(1);
                }, function () {
                    //console.log('Modal dismissed at: ' + new Date());
                });
            } else {
                //如果收藏状态，则取消收藏
                if ($scope.fav.is_fav == "img_icon_heart") {
                    //取消收藏
                    set_fav_func(0);
                } else {
                    //添加收藏
                    set_fav_func(1);
                }
            }
        };
    }
        //--------------------------页面初始化数据-----------
        {
        show_product();
        show_comm();
        //活动简介列表
        Promotion.promlist_short($stateParams.prod_Id).then(function (data) {
            $scope.promlist = data.prom;
        });
        //收藏按钮
        $scope.fav = {is_fav: "img_icon_heart_outline"};
        if (Auth.islogin()) {
            //判断是否收藏
            MyFavorite.is_fav($stateParams.prod_Id).then(function (data) {
                if (data.code == "1") {
                    if (data.msg == "1") {
                        $scope.fav.is_fav = "img_icon_heart";
                    } else {
                        $scope.fav.is_fav = "img_icon_heart_outline";
                    }
                } else {
                    $scope.fav.is_fav = "img_icon_heart_outline";
                }
            });
        }

        //判断是否显示游戏
        if ($stateParams.game_type == 1) {
            show_game();
        }
    }
        //--------------------------页面重新加载数据----------
        {
            $scope.view_iscache = false;
            $scope.$on('$ionicView.leave', function () {
                $scope.view_iscache = true;
            });
            $scope.$on('$ionicView.beforeEnter', function () {
                if($scope.view_iscache){
              //      console.log("cache");
                  //  show_product();
                    update_comm_count();
                    if($scope.commlist.length < 2){
                        show_comm();
                    }
                }
            });
        }
    })
    .controller('CommlistCtrl', function ($scope, $stateParams,$state,$timeout,Comment,Product) {
        $scope.post_conf = {
            prod_id:$stateParams.prod_Id,
            page_size: 10,
            page_index: 0,
            desc_col: "score"
        };
        //是否需要显示下拉刷新
        $scope.flag = {
            show_all:-1,
            showmore:false,
            result:""
        };
        //开关commcontent
        $scope.show_all = function (index) {
          if($scope.flag.show_all==index){
              $scope.flag.show_all = -1;
          }else{
              $scope.flag.show_all = index;
          }
        };
        var func_show_product = function () {
            $scope.prod = {};
            Product.prod_info_short($stateParams.prod_Id).then(function (data) {
                $scope.prod.comment_num = data.comment_num;
                //获取对应views的路由url
               // var url_arr = $location.path().split("/");
               // $scope.prod.commlist_url = "#/addcomm/"+$scope.prod.prod_id;
            });
        };
        $scope.go_addcomm = function () {
            $state.go('addcomm',{'prod_Id':$stateParams.prod_Id});
        };
        var func_show_commlist = function (init) {
            if(init){
                $scope.commlist = [];
                $scope.post_conf.page_index = 0
            }else{
                $scope.post_conf.page_index ++;
            }

            Comment.comment_list($scope.post_conf).then(function (data) {
                //为空返回
                if (data.code != 1) {
                    $scope.flag.showmore =false;
                    if($scope.commlist.length==0){
                        $scope.flag.result ="该产品当前没有评论信息！";
                    }
                    $scope.$broadcast("scroll.infiniteScrollComplete");
                    return;
                }
                for (var i = 0; i < data.msg.length; i++) {
                    var p = data.msg[i];
                    p.ratingStates = [
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                        {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}
                    ];
                    if (p.score == null || p.score == 0) {
                        p.rating = 5;
                    }else if(p.score >0 && p.score <20){
                        p.rating =1;
                        p.ratingStates[0] = {
                            stateOn: 'ion-ios-star-half',
                            stateOff: 'ion-ios-star-outline'
                        };
                    } else {
                        p.rating = Math.floor(p.score / 20);
                        //如果有半星的话
                        if (p.score% 20 != 0) {
                            p.ratingStates[Math.floor(p.score / 20)+1] = {
                                stateOn: 'ion-ios-star-half',
                                stateOff: 'ion-ios-star-outline'
                            };
                        }
                    }
                    $scope.commlist.push(p);
                }
                if($scope.commlist.length >= $scope.post_conf.page_size)
                {
                    $timeout(function() {
                        $scope.flag.showmore = true;
                    },1000);
                }
                $scope.$broadcast("scroll.infiniteScrollComplete");
            });
        };
        $scope.load_more = function () {
            $scope.post_conf.page_index++;
            $timeout(function () {
                func_show_commlist(false);
            },500);
        };
        func_show_product();
        func_show_commlist(true);
//缓存------------------------------------
        $scope.view_iscache = false;
        $scope.$on('$ionicView.leave', function () {
            $scope.view_iscache = true;
        });
        $scope.$on('$ionicView.beforeEnter', function () {
            if($scope.view_iscache){
                func_show_product();
                func_show_commlist(true);
            }
        });
    })
    .controller('AddCommCtrl', function ($scope,$ionicHistory,$stateParams,$modal,$ionicPopup,BASE, Product,Comment,Auth) {
        $scope.comm = {
            text:"",
            rating: 5
        };
        Product.prod_info_short($stateParams.prod_Id).then(function (data) {
            var p = data;
            p.ratingStates = [
                {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'},
                {stateOn: 'ion-ios-star', stateOff: 'ion-ios-star-outline'}
            ];
            p.img_path = BASE.url+p.img_path;
            if (p.average == null || p.average == 0) {
                p.rating = 5;
            } else if (p.average == 100) {
                p.rating = 5;
            } else {
                p.rating = Math.floor(p.average / 20) + 1;
                //如果有半星的话
                if (p.average % 20 != 0) {
                    p.ratingStates[Math.floor(p.average / 20)] = {
                        stateOn: 'ion-ios-star-half',
                        stateOff: 'ion-ios-star-outline'
                    };
                }
            }
            $scope.prod = p;
        });
        $scope.data =  {
            phone: "",
            token: "",
            prod_id:$stateParams.prod_Id,
            score: 3,
            content: "",
            position:"beijing"
        };
        $scope.post_comm = function () {
            if($scope.comm.text == "")
            {
                // 确认弹出框
                $ionicPopup.alert({
                    title: "提示信息",
                    template: "评论内容为空！"
                });
                return;
            }
            if(!Auth.islogin())
            {
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function () {
                        $scope.$broadcast('post-comment');
                }, function () {
                    //console.log('Modal dismissed at: ' + new Date());
                });
            }else{
                $scope.$broadcast('post-comment');
            }
        };
        $scope.$on('post-comment', function () {
            $scope.data.phone = Auth.getUser().phone;
            $scope.data.token = Auth.getUser().token;
            $scope.data.score = $scope.comm.rating*20;
            $scope.data.content = $scope.comm.text;
           // alert($scope.comm.text);
            Comment.comment_add($scope.data).then(function (data) {
               // alert(JSON.stringify(data));
                if(data.code == "1"){
                    $ionicHistory.goBack();
                }else if(data.code == "-4"){
                    var modalInstance = $modal.open({
                        animation: 'side-in-up',
                        templateUrl: 'templates/modal/to_login.html',
                        size: 'margin',
                        windowClass:'modal_sdb',
                        backdropClass:"modal_sdb_drop",
                        controller: 'ModalLoginCtrl'
                    });
                    modalInstance.result.then(function () {
                            $scope.$broadcast('post-comment');
                    }, function () {
                        //console.log('Modal dismissed at: ' + new Date());
                    });
                }
            })
        })
    })
    .controller('UserCtrl', function ($scope,$ionicActionSheet,$ionicPopup,$state,BASE,Auth) {
        $scope.msg = {info: "未登陆"};
        $scope.user = {};
        $scope.user_mata = {};
        if (Auth.islogin()) {
            $scope.msg.info = "已登录";
            $scope.user = Auth.getUser();
            $scope.user_meta = Auth.user_meta_info();
            $scope.user_meta.img_url = BASE.url + Auth.user_meta_info().img_path;
        } else {
            $scope.msg.info = "未登录";
            $scope.user = {};
        }
        var upload_img = function (file_path) {
            // Do any magic you need
            var win = function (r) {
              //  alert("s: "+JSON.stringify(r));
                //TODO:第二次发送不成功，待处理，先跳过去，继续开发
                upload_img('123');
                var tmp_data = Auth.user_meta_info();
                tmp_data.img_path = "img/users/" + $scope.user.phone+".jpg";
                Auth.set_user_info(tmp_data);
                $scope.user_meta.img_url = BASE.url + tmp_data.img_path + "?r=" + Math.random();
                $state.reload();
            };
            var fail = function (error) {
              //  alert("e: " + JSON.stringify(error));
            };
            var options = new FileUploadOptions();
            options.fileKey = "user_img";
            options.fileName = $scope.user.phone;
            var ft = new FileTransfer();
            ft.upload(file_path, encodeURI(BASE.url + BASE.update_user_img), win, fail, options);
        };
        $scope.update_img = function () {
            $ionicActionSheet.show({
                buttons: [
                    { text: "拍照" },
                    { text: "相册" }
                ],
                buttonClicked: function(index) {
                    //打开相机
                    if(index == 0){
                        navigator.camera.getPicture(function(result) {
                            // Do any magic you need
                            upload_img(result);
                        }, function(err) {
                           // alert(err);
                        }, {
                            quality: 90,
                            targetWidth: 500,
                            targetHeight: 500,
                            allowEdit:true,
                            saveToPhotoAlbum: false
                        });
                    }else if(index == 1){//打开相册
                        navigator.camera.getPicture(function(result) {
                          //  alert(result);
                            upload_img(result);
                        }, function(err) {
                          //  alert("e: " + err);
                        }, {
                            quality: 90,
                            targetWidth: 200,
                            targetHeight: 200,
                            allowEdit:true,
                            saveToPhotoAlbum: false,
                            sourceType:Camera.PictureSourceType.PHOTOLIBRARY
                        });
                    }
                    return true;
                },
                cancelText: "取消"
            });
        };
        $scope.update_sex = function () {
            $ionicActionSheet.show({
                buttons: [
                    { text: "男" },
                    { text: "女" }
                ],
                buttonClicked: function(index) {
                    var tmp_data = {};
                    tmp_data = $scope.user;
                    tmp_data.nickname = $scope.user_meta.nickname;
                    if(index == 1){
                        tmp_data.sex = 0;
                    }else{
                        tmp_data.sex = 1;
                    }
                    tmp_data.area_id = $scope.user_meta.default_area;
                    Auth.update_user_info(tmp_data).then(function (res) {
                        if(res.code == 1){
                            $scope.user_meta.sex = tmp_data.sex;
                            Auth.set_user_info($scope.user_meta);
                        }
                    });
                    return true;
                },
                cancelText: "取消"
            });
        };
        $scope.update_area = function () {

        };
        $scope.update_nickname = function () {
            $scope.data = {};
            $scope.data.nickname = $scope.user_meta.nickname;
            // 调用$ionicPopup弹出定制弹出框
            $ionicPopup.show({
                template: "<input type='txt' ng-model='data.nickname'><p>字数限制：xxx</p>",
                title: "修改昵称",
                scope: $scope,
                buttons: [
                    { text: "取消" },
                    {
                        text: "保存",
                        type: "button-positive",
                        onTap: function(e) {
                            return $scope.data.nickname;
                        }
                    }
                ]
            })
            .then(function(res) {
                if(res != undefined){
                    if(res!=""){
                        var tmp_data = {};
                        tmp_data = $scope.user;
                        tmp_data.nickname = res;
                        tmp_data.sex = $scope.user_meta.sex;
                        tmp_data.area_id = $scope.user_meta.default_area;
                        Auth.update_user_info(tmp_data).then(function (res) {
                            if(res.code == 1){
                                $scope.user_meta.nickname = tmp_data.nickname;
                                Auth.set_user_info($scope.user_meta);
                            }
                        });
                    }
                }
            });
        };
    })
    .controller('SettingCtrl', function ($scope, $ionicPopup,$ionicHistory,$modal,Auth) {
        $scope.user = {};
        if (Auth.islogin()) {
            $scope.user.phone = Auth.getUser().phone;
            $scope.user.token = Auth.getUser().token;
        }

        //登出
        $scope.logout = function () {

            // 确认弹出框
            $ionicPopup.confirm({
                title: "确定退出登录么？",
                buttons: [
                    { text: "取消"},
                    {
                        text: "<b>确定</b>",
                        type: "button-assertive",
                        onTap: function(e) {
                            return true;
                        }
                    }
                ]
            })
            .then(function(res) {
                if(res) {
                    Auth.logout();
                    $scope.user = {};
                    $ionicHistory.goBack();
                }
            });

        };
    })
    .controller('MyAwardsCtrl', function ($scope, $modal,$ionicPopup,$state,MyAwards,Game) {
        $scope.result = "";
        var show_awards = function () {
            $scope.alist = [];
            MyAwards.check_unopen().then(function (data) {
                if(data.code == 1){
                    $scope.alist = data.msg;
                }else if(data.code == -4){
                    var modalInstance = $modal.open({
                        animation: 'side-in-up',
                        templateUrl: 'templates/modal/to_login.html',
                        size: 'margin',
                        windowClass:'modal_sdb',
                        backdropClass:"modal_sdb_drop",
                        controller: 'ModalLoginCtrl'
                    });
                    modalInstance.result.then(function () {
                        show_awards();
                    }, function () {
                        //console.log('Modal dismissed at: ' + new Date());
                    });
                }else{
                    $scope.result = data.msg;
                }
            })
        };
        $scope.open_award = function (award) {
           // console.log(award.qr_code);
            //解析二维码数据
            Game.decode_p(award.qr_code).then(function (data) {
                if(data.code =="1"){
                    //判断二维码是否用过
                    if (data.msg.is_used == "0") {
                        //跳转产品页
                        $state.go('productinfo', {prod_Id: data.msg.prod_id, game_type: "1"});
                    } else {
                        $state.go('productinfo', {prod_Id: data.msg.prod_id, game_type: "0"});
                        $ionicPopup.alert({
                            title: "提示信息",
                            template: "该二维码已用！"
                        });
                    }
                }else if(data.code==-1){
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "参数错误！"
                    });
                }else if(data.code==-2){
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "非扫得宝二维码！"
                    });
                }else{
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "未知错误！"
                    });
                }

            });
        };
        //--------------------------页面重新加载数据----------
        {
            $scope.view_iscache = false;
            $scope.$on('$ionicView.leave', function () {
                $scope.view_iscache = true;
            });
            $scope.$on('$ionicView.beforeEnter', function () {
                if($scope.view_iscache){
                    show_awards();
                }
            });
        }
        //展示奖励
        show_awards();
    })
    .controller('MyShareCtrl', function ($scope, $modal,SysInfo,Auth) {
        $scope.code = "";
        if (Auth.islogin()) {
            $scope.code = Auth.user_meta_info().my_code;
        } else {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_login.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalLoginCtrl'
            });
            modalInstance.result.then(function () {
                $scope.code = Auth.user_meta_info().my_code;
            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        }
        $scope.to_share = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_share.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalShareCtrl',
                resolve: {
                    data: function () {
                        var share_data = {};
                        share_data.type = 'URL';
                        share_data.title = '扫得宝就是好，邀你一起来抢宝！';
                        share_data.description = '这是给新伙伴的大礼，快来领取吧~';
                        share_data.webpageUrl = 'http://sdb.topjwd.com/s/invitation/'+ $scope.code;
                        return share_data;
                    }
                }
            });
            modalInstance.result.then(function () {

            }, function () {

            });
        };
        $scope.open_info = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/show_content.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalShowContentCtrl',
                resolve: {
                    c_id: function () {
                        return 2;//规则说明
                    }
                }
            });
            modalInstance.result.then(function () {
            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
        $scope.get_award = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/get_award.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalGetAwardCtrl'
            });
            modalInstance.result.then(function () {

            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
    })
    .controller('FeedbackCtrl', function ($scope,$modal,$ionicHistory,$ionicPopup,MyAwards,Auth) {
        $scope.user = {};
        $scope.feedback={
            content:"",
            contact_info:""
        };
        var func_add_feedback = function () {
            var tmp_data = {
                phone:Auth.getUser().phone,
                token:Auth.getUser().token,
                content:$scope.feedback.content,
                contact_info:$scope.feedback.contact_info
            };
            MyAwards.add_feedback(tmp_data).then(function (data) {
                if(data.code == 1){
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "反馈信息提交成功！"
                    });
                }else{
                    $ionicPopup.alert({
                        title: "提示信息",
                        template: "提交失败！" + data.msg
                    });
                }
                $ionicHistory.goBack();
            });
        };
        $scope.add_feedback = function () {
            if(!Auth.islogin()){
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function () {
                    func_add_feedback();
                }, function () {
                    //console.log('Modal dismissed at: ' + new Date());
                });
            }else{
                func_add_feedback();
            }
        };

    })
    .controller('AboutCtrl', function ($scope,$ionicPopup,SysInfo) {
        $scope.sdb = {
            app_version:SysInfo.get_app_version()
        };
        if(ionic.Platform.isAndroid()) {
            //检查是否需要更新，读取在线最新版本
            SysInfo.get_online_version().then(function (data) {
                if (data.code == 1) {
                    if (data.msg.version > SysInfo.get_app_version()) {
                        $ionicPopup.confirm({
                            title: "版本更新",
                            template: "发现新版本，是否更新？",
                            buttons: [
                                {text: "取消"},
                                {
                                    text: "<b>确认</b>",
                                    type: "button-positive",
                                    onTap: function () {
                                        return true;
                                    }
                                }
                            ]
                        })
                            .then(function (res) {
                                if (res) {
                                    cordova.InAppBrowser.open(SysInfo.get_app_download_url(), '_system', 'location=yes');
                                }
                            });
                    }
                }
            });
        }
    })
    .controller('AccountCtrl', function ($scope, $modal, $state,$ionicHistory,BASE,MyAwards, Msg,Auth) {
        $scope.msg = {
            hasmsg:false,
            info: "未登陆"
        };
        $scope.user = {};
        $scope.account = {
            my_coupons_count: 0,
            my_favorites_count: 0,
            my_games_count: 0,
            my_money: 0,
            my_point_card_count: 0,
            my_unopen_count: 0
        };
        var show_account_data = function () {
            if (Auth.islogin()) {
                $scope.msg.info = "已登录";
                $scope.user = Auth.getUser();
                $scope.user.nickname = Auth.user_meta_info().nickname;
                var fv = $ionicHistory.viewHistory().forwardView;
                if(fv != null && fv.stateName == "account-user"){
                    $scope.user.img_path = BASE.url + Auth.user_meta_info().img_path + "?r=" + Math.random();
                }else{
                    $scope.user.img_path = BASE.url + Auth.user_meta_info().img_path;
                }
                //我的页面各种数量
                MyAwards.my_count().then(function (data) {
                   // console.log(data);
                    if(data.code == 1){
                        $scope.account = data.msg;
                    }else if(data.code == -4){
                        Auth.logout();
                        $scope.msg.info = "未登录";
                        $scope.user = {};
                        $scope.account = {};
                        return;
                    }
                });
                //未读消息
                Msg.has_message($scope.user).then(function (data) {
                    if(data.code =="1"){
                        $scope.msg.hasmsg = data.msg;
                    }
                });
            } else {
                $scope.msg.info = "未登录";
                $scope.user = {};
                $scope.account = {};
            }
        };
        var login_to = function (url) {
            if (!Auth.islogin()) {
                var modalInstance = $modal.open({
                    animation: 'side-in-up',
                    templateUrl: 'templates/modal/to_login.html',
                    size: 'margin',
                    windowClass:'modal_sdb',
                    backdropClass:"modal_sdb_drop",
                    controller: 'ModalLoginCtrl'
                });
                modalInstance.result.then(function () {
                    $state.go(url);
                }, function () {
                    //console.log('Modal dismissed at: ' + new Date());
                });
            } else {
                $state.go(url);
            }
        };
        $scope.open_rules = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/show_content.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalShowContentCtrl',
                resolve: {
                    c_id: function () {
                        return 1;//规则说明
                    }
                }
            });
            modalInstance.result.then(function () {
                show_account_data();
            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
        //点击去登陆
        $scope.open_login = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_login.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalLoginCtrl'
            });
            modalInstance.result.then(function () {
                show_account_data();
            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
        //跳转消息页
        $scope.go_msglist = function () {
            login_to("msglist");
        };
        $scope.goto_moneydetail = function () {
            login_to("money_detail");
        };
        $scope.goto_fav = function () {
            login_to("favorite");
        };
        $scope.goto_myawards = function () {
            login_to('my-awards');
        };
        $scope.goto_myshare = function () {
            login_to('my-share');
        };
        $scope.goto_mycoupons = function () {
            login_to('my-coupons');
        };
        $scope.goto_c_card = function () {
            login_to('my-collection-card');
        };
        $scope.$on('$ionicView.beforeEnter', function () {
            show_account_data();
        });
    })
    .controller('ModalToAlipayCtrl', function ($scope, $modalInstance, draw_info,Mywallet) {
        $scope.closeAlipayModal = function () {
            $modalInstance.dismiss('cancel');
        };
        $scope.draw = {
            balance: draw_info.money,//余额
            alipay_id: draw_info.alipay_id,
            alipay_name: draw_info.alipay_name,
            money: ""//提现金额
        };
        //alert 提示信息
        $scope.alerts = [];
        $scope.closeAlert = function (index) {
            $scope.alerts.splice(index, 1);
        };
        $scope.$watch('draw.money', function () {
            if($scope.draw.money*100 > draw_info.money){
                $scope.draw.money = Math.floor(draw_info.money/100);
            }
        });
        //提现按钮
        $scope.withdraw = function () {
            if ($scope.draw.alipay_id == "" || $scope.draw.alipay_name == "" || $scope.draw.money == ""){
                $scope.alerts.push({type: "danger", msg: "id|name|money 为空！"});
                return;
            }
            Mywallet.user_withdraw($scope.draw.alipay_id,$scope.draw.alipay_name,$scope.draw.money*100).then(function (data) {
                if(data.code == 1){
                    $modalInstance.close('withdraw-success');
                }else{
                    $modalInstance.dismiss('withdraw-fail');
                }
            })
        };
    })
    .controller('ModalGameGoldBeanCtrl', function ($scope, $modal, $modalInstance,$timeout,BASE, prom_info,Game,Auth) {
        $scope.closeGameModal = function () {
            $modalInstance.dismiss('cancel');
        };
        //游戏开始数据
        $scope.game_info = {
            brand_img: BASE.url + prom_info.brand_img,
            brand_name: prom_info.brand_name,
            is_excode: prom_info.is_excode,//是否需要扩展名，1为需要
            excode:"",
            result:0,//结果
            msg:"",
            result_url:"my-coupons",
            everyone_url:"luck_list"
        };
        //---------------------自定义函数-----------------
        //登录后打开礼包
        var login_and_open_game = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_login.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalLoginCtrl'
            });
            modalInstance.result.then(function () {
                func_open_game();
            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
        //打开礼包函数
        var func_open_game = function () {
            Game.user_add_dou($scope.game_info.excode).then(function (data) {
                if (data.code == 1) {
                    Game.set_game_result(data.msg);
                    $scope.game_info.result = data.msg;
                } else if (data.code == -4) {
                    login_and_open_game();
                }
                else {
                    $scope.game_info.msg = data.msg;
                    $timeout(function () {
                            $scope.game_info.msg ="";
                    },2000);
                }
            });
        };
        //-----------------------------按钮函数--------------------
        //打开礼包按钮
        $scope.open_game = function () {
            if (!Auth.islogin()) {
                login_and_open_game();
            } else {
                func_open_game();
            }
        };
        //关闭窗口查看优惠券
        $scope.go_result = function () {
            var tmp_data =[];
            tmp_data.push($scope.game_info.result_url);
            $modalInstance.close(tmp_data);
        };
        //看看大家手气
        $scope.go_everyone = function () {
            var tmp_data =[];
            tmp_data.push($scope.game_info.everyone_url);
            tmp_data.push({prom_id:prom_info.prom_id});
            $modalInstance.close(tmp_data);
        };
    })
    .controller('ModalGameCollectionCardCtrl', function ($scope, $modal, $modalInstance,$timeout,BASE, prom_info,Game,Auth) {
        $scope.closeGameModal = function () {
            $modalInstance.dismiss('cancel');
        };
        //游戏开始数据
        $scope.game_info = {
            brand_img: BASE.url + prom_info.brand_img,
            brand_name: prom_info.brand_name,
            is_excode: prom_info.is_excode,//是否需要扩展名，1为需要
            excode: "",//扩展码
            result:0,//结果
            msg:"",
            result_img:"img/modal/c_card_result_img.png",
            result_url:"my-collection-card"
        };
        //---------------------自定义函数-----------------
        //登录后打开礼包
        var login_and_open_game = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_login.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalLoginCtrl'
            });
            modalInstance.result.then(function () {
                func_open_game();
            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
        //打开礼包函数
        var func_open_game = function () {
            Game.user_add_dou($scope.game_info.excode).then(function (data) {
                if (data.code == 1) {
                    Game.set_game_result(data.msg);
                    $scope.game_info.result = data.msg;
                } else if (data.code == -4) {
                    login_and_open_game();
                }
                else {
                    $scope.game_info.msg = data.msg;
                    $timeout(function () {
                        $scope.game_info.msg ="";
                    },2000);
                }
            });
        };
        //-----------------------------按钮函数--------------------
        //打开红包按钮
        $scope.open_game = function () {
            if (!Auth.islogin()) {
                login_and_open_game();
            } else {
                func_open_game();
            }
        };
        //关闭窗口查看账户明细或者优惠券
        $scope.go_result = function () {
            var tmp_data =[];
            tmp_data.push($scope.game_info.result_url);
            $modalInstance.close(tmp_data);
        };
    })
    .controller('ModalGameBounsCtrl', function ($scope, $modal, $modalInstance,$timeout,BASE, prom_info,Game,Auth) {
        $scope.closeGameModal = function () {
            $modalInstance.dismiss('cancel');
        };
        //游戏开始数据
        $scope.game_info = {
            brand_img: BASE.url + prom_info.brand_img,
            brand_name: prom_info.brand_name,
            is_excode: prom_info.is_excode,//是否需要扩展名，1为需要
            excode:"",
            result:0,//结果
            msg:"",
            result_url:"money_detail",
            everyone_url:"luck_list"
        };
        //---------------------自定义函数-----------------
        //登录后打开礼包
        var login_and_open_game = function () {
            var modalInstance = $modal.open({
                animation: 'side-in-up',
                templateUrl: 'templates/modal/to_login.html',
                size: 'margin',
                windowClass:'modal_sdb',
                backdropClass:"modal_sdb_drop",
                controller: 'ModalLoginCtrl'
            });
            modalInstance.result.then(function () {
                func_open_game();
            }, function () {
                //console.log('Modal dismissed at: ' + new Date());
            });
        };
        //打开礼包函数
        var func_open_game = function () {
            Game.open_bonus($scope.game_info.excode).then(function (data) {
                // alert(JSON.stringify(data));
                if (data.code == "1") {
                    Game.set_game_result(data.msg);
                    $scope.game_info.result = data.msg / 100;
                } else if (data.code == "-4") {
                    login_and_open_game();
                }
                else {
                    $scope.game_info.msg = data.msg;
                    $timeout(function () {
                        $scope.game_info.msg ="";
                    },2000);
                }
            });
        };
        //-----------------------------按钮函数--------------------
        //拆红包按钮
        $scope.open_game = function () {
            if (!Auth.islogin()) {
                login_and_open_game();
            } else {
                func_open_game();
            }
        };
        //关闭窗口查看账户余额
        $scope.go_result = function () {
            var tmp_data =[];
            tmp_data.push($scope.game_info.result_url);
            $modalInstance.close(tmp_data);
        };
        //看看大家手气
        $scope.go_everyone = function () {
            var tmp_data =[];
            tmp_data.push($scope.game_info.everyone_url);
            tmp_data.push({prom_id:prom_info.prom_id});
            $modalInstance.close(tmp_data);
        };
    })
    .controller('ModalShowPromCtrl', function ($scope, $modalInstance,$state) {
        $scope.closeShowPromModal = function () {
            $modalInstance.dismiss('cancel');
        };
        $scope.go_detail = function () {
            $modalInstance.close();
            $state.go('adprom-info',{adprom_id:7});
        };
    })
    .controller('ModalPromInfoCtrl', function ($scope, $modalInstance,prom_info) {
        $scope.closePromInfoModal = function () {
            $modalInstance.dismiss('cancel');
        };
        $scope.prom = prom_info;
       // console.log($scope.prom);
    })
    .controller('ModalGetAwardCtrl', function ($scope, $modalInstance,MyAwards) {
        $scope.closeAwardModal = function () {
            $modalInstance.dismiss('cancel');
        };
        $scope.award = {
            code:"",
            result:""
        };
        $scope.get_award = function () {
            MyAwards.input_invitation_code($scope.award.code).then(function (data) {
                if(data.code == 1){
                    $scope.award.result = "恭喜获得大礼包，请到我的奖励中查询。"
                }else{
                    $scope.award.result = data.msg;
                }
            })
        }
    })
    .controller('ModalShowContentCtrl', function ($scope, $modalInstance,c_id,SysInfo) {
        $scope.closeShowContentModal = function () {
            $modalInstance.dismiss('cancel');
        };
        $scope.modal_content = {title:"",content:""};
        SysInfo.sys_info(c_id).then(function (data) {
            if(data.code == 1){
                $scope.modal_content.title = data.msg.name;
                $scope.modal_content.content = data.msg.content;
            }
        });

    })
    .controller('ModalShareCtrl', function ($scope, $modalInstance,data) {
        $scope.closeShareModal = function () {
            $modalInstance.dismiss('cancel');
        };
        var params = {};
        if(data.type == 'text'){
            params.text = data.text;
        }else if(data.type == 'URL') {
            params.message = {
                title: data.title,
                description: data.description,
                thumb: "www/img/sdb_icon.png",
                media: {
                    type : Wechat.Type.LINK,
                    webpageUrl: data.webpageUrl
                }
            };
        }else {
            params.message = {
                title: "[TEST]",
                description: "[TEST]Sending from test application",
                thumb: "www/img/sdb_icon.png",
                media: {
                    type:Wechat.Type.LINK,
                    webpageUrl:"http://sdb.topjwd.com/s"
                }
            };
        }
        $scope.check_weixin = function () {
            Wechat.isInstalled(function (installed) {
                alert("Wechat installed: " + (installed ? "Yes" : "No"));
            }, function (reason) {
                alert("Failed: " + reason);
            });
        };
        $scope.share_session = function () {
            params.scene = Wechat.Scene.SESSION;
            Wechat.share(params, function () {
                $modalInstance.close("share-success");
            }, function (reason) {
              //  alert("Failed: " + reason);
                $modalInstance.dismiss('cancel');
            });
        };
        $scope.share_timeline = function () {
            params.scene = Wechat.Scene.TIMELINE;
            Wechat.share(params, function () {
                $modalInstance.close("share-success");
            }, function (reason) {
             //   alert("Failed: " + reason);
                $modalInstance.dismiss('cancel');
            });
        };
    })
    .controller('ModalLoginCtrl', function ($scope, $modalInstance, $timeout,Auth) {
    $scope.closeLoginModal = function () {
        $modalInstance.dismiss('cancel');
    };
    $scope.login_user = {"phone": "", "code": "",test:false};
    $scope.btn = {
        disabled:false,
        txt:"验证"
    };
    //发送验证短信
    $scope.send_sms = function () {
        Auth.send_sms($scope.login_user.phone).then(function (data) {
            if(data.code == 1){
                $scope.btn.disabled = true;
                $scope.btn.txt = 60;
                cal_time();
            }
        });
    };
    //倒计时
    var cal_time = function () {
        $timeout(function () {
            $scope.btn.txt--;
            if($scope.btn.txt != 0)
            {
                cal_time();
            }else{
                $scope.btn.txt = "验证";
                $scope.btn.disabled = false;
            }
        },1000);
    };
    //alert 提示信息
    $scope.alerts = [];
    $scope.closeAlert = function (index) {
        $scope.alerts.splice(index, 1);
    };
    //登陆
    $scope.login = function () {
        //#todo：test user
        if($scope.login_user.phone=='15810018877'){
            $scope.login_user.phone = '1581001887';
        }
        Auth.login($scope.login_user.phone, $scope.login_user.code).then(function (res) {
            //登陆成功，广播事件
            if(res.code == undefined){
                $scope.alerts = [];
                $scope.alerts.push({type: "danger", msg: "网络连接异常，请尝试重新登录！"});
                return;
            }
            if (res.code == 1) {
               // $scope.alerts.push({type: "success", msg: "login success!"});
                $modalInstance.close("login-success");
            } else if(res.code < 0 ){
                $scope.alerts = [];
                $scope.alerts.push({type: "danger", msg: res.msg});
            } else{
                $scope.alerts = [];
                $scope.alerts.push({type: "danger", msg: JSON.stringify(res)});
            }
        });
    };

});
