angular.module('sdb.routers', [])
    .config(function($stateProvider, $urlRouterProvider) {
// Ionic uses AngularUI Router which uses the concept of states
// Learn more here: https://github.com/angular-ui/ui-router
// Set up the various states which the app can be in.
// Each state's controller can be found in controllers.js
        $stateProvider
            //引导页
            .state('splash', {
                url: "/splash",
                controller: 'SplashCtrl',
                templateUrl: "templates/splash.html"
            })
            //主页精简按钮版
            .state('main', {
                url: '/main',
                templateUrl: 'templates/main.html',
                controller: 'MainCtrl'
            })
            //区域城市
            .state('area-city', {
                url: '/area-city',
                templateUrl: 'templates/area-city.html',
                controller: 'AreaCityCtrl'
            })
            //类别页
            .state('category', {
                url: '/category',
                templateUrl: 'templates/category.html',
                controller: 'CategoryCtrl'
            })
            //品牌
            .state('brand', {
                url: '/brand',
                templateUrl: 'templates/tab-brand.html',
                controller: 'BrandCtrl'
            })
            //品牌产品列表
            .state('brand-prodlist', {
                url: '/brand/prodlist/:bid',
                templateUrl: 'templates/brand-prodlist.html',
                controller: 'BrandProdlistCtrl'
            })
            //产品信息-主页
            .state("productinfo", {
                url: '/product/:prod_Id/:game_type',
                templateUrl: 'templates/product-info.html',
                controller: 'ProductinfoCtrl'
            })
            //产品详情
            .state("product-detail", {
                url: '/prod_detail/:prod_Id',
                templateUrl: 'templates/product-detail.html',
                controller: 'ProductdetailCtrl'
            })
            //评论列表页-主页
            .state('commlist', {
                url: '/commlist/:prod_Id',
                templateUrl: 'templates/tab-commlist.html',
                controller: 'CommlistCtrl'
            })
            //添加评论页-主页
            .state('addcomm', {
                url: '/addcomm/:prod_Id',
                templateUrl: 'templates/product-addcomm.html',
                controller: 'AddCommCtrl'
            })
            //消息列表
            .state("msglist", {
                url: '/msglist',
                templateUrl: 'templates/tab-msglist.html',
                controller: 'MsglistCtrl'
            })
            //消息内容
            .state("msginfo", {
                url: '/msglist/:msg_idx',
                templateUrl: 'templates/tab-msginfo.html',
                controller: 'MsginfoCtrl'
            })
            //热门搜索
            .state("search", {
                url: '/search',
                templateUrl: 'templates/tab-search.html',
                controller: 'SearchCtrl'
            })
            //热门活动
            .state("adprom-list", {
                url: '/adprom-list',
                templateUrl: 'templates/adprom-list.html',
                controller: 'AdpromListCtrl'
            })
            //活动详情
            .state("adprom-info", {
                url: '/adprom-info/:adprom_id',
                templateUrl: 'templates/adprom-info.html',
                controller: 'AdpromInfoCtrl'
            })
            //主页下查看大家手气
            .state("luck_list", {
                url: '/luck_list/:prom_id',
                templateUrl: 'templates/luck_list.html',
                controller: 'LucklistCtrl'
            })
            //我的------------------------------------------
            .state('account', {
                url: '/account',
                templateUrl: 'templates/tab-account.html',
                controller: 'AccountCtrl'
            })
            //我的钱包
            .state("money_detail", {
                url: '/account/money_detail',
                templateUrl: 'templates/money_detail.html',
                controller: 'MoneydetailCtrl'
            })
            //我的优惠券
            .state("my-coupons", {
                url: '/account/my-coupons',
                templateUrl: 'templates/my-coupons.html',
                controller: 'MyCouponsCtrl'
            })
            //我的集点卡
            .state("my-collection-card", {
                url: '/account/my-collection-card',
                templateUrl: 'templates/my-collection-card.html',
                controller: 'MyCollectionCardCtrl'
            })
            //我的奖励 详情
            .state("award_detail", {
                url: '/account/award_detail/:award_id',
                templateUrl: 'templates/award_detail.html',
                controller: 'AwardDetailCtrl'
            })
            //未领取的奖励
            .state("my-awards", {
                url: '/account/my-awards',
                templateUrl: 'templates/my-awards.html',
                controller: 'MyAwardsCtrl'
            })
            //我的分享
            .state("my-share", {
                url: '/account/my-share',
                templateUrl: 'templates/my-share.html',
                controller: 'MyShareCtrl'
            })
            //收藏
            .state('favorite', {
                url: '/account/favorite',
                templateUrl: 'templates/tab-favorite.html',
                controller: 'FavoriteCtrl'
            })
            //个人中心
            .state('account-user', {
                url: '/account/user',
                templateUrl: 'templates/account-user.html',
                controller: 'UserCtrl'
            })
            //设置
            .state('account-setting', {
                url: '/account/setting',
                templateUrl: 'templates/account-setting.html',
                controller: 'SettingCtrl'
            })
            //意见反馈
            .state('account-feedback', {
                url: '/account/feedback',
                templateUrl: 'templates/account-feedback.html',
                controller: 'FeedbackCtrl'
            })
            //展示页面
            .state('show_page', {
                url: '/show_page/:page_id',
                templateUrl: 'templates/show_page.html',
                controller: 'ShowPageCtrl'
            })
            //关于我们
            .state('account-about', {
                url: '/account/about',
                templateUrl: 'templates/account-about.html',
                controller: 'AboutCtrl'
            });

// if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/main');
    });